/***************************** LICENSE START ***********************************

 Copyright 2014 ECMWF and INPE. This software is distributed under the terms
 of the Apache License version 2.0. In applying this license, ECMWF does not
 waive the privileges and immunities granted to it by virtue of its status as
 an Intergovernmental Organization or submit itself to any jurisdiction.

 ***************************** LICENSE END *************************************/

#include "MvQAdvancedSearch.h"

#include <QCheckBox>
#include <QDialogButtonBox>
#include <QHBoxLayout>
#include <QLabel>
#include <QPushButton>
#include <QTabWidget>
#include <QToolButton>
#include <QTreeWidget>
#include <QVBoxLayout>

#include "MvQLineEdit.h"

//================================================
// 
//  MvQAdvancedSearchDialog
//
//================================================

MvQAdvancedSearchDialog::MvQAdvancedSearchDialog(QWidget *parent) : 
      QDialog(parent)
{  
	QVBoxLayout *vb=new QVBoxLayout;
	vb->setSpacing(2); 
	vb->setContentsMargins(4,4,4,4);
	setLayout(vb);
	
	QTabWidget *tab=new QTabWidget(this);
	vb->addWidget(tab);
	
	//------------------
	// Main tab
	//------------------
	
	QGridLayout *gridLayout=new QGridLayout;
	
	QWidget *w=new QWidget;	
	w->setLayout(gridLayout);	
	tab->addTab(w,tr("&Name"));
	
	int row=0;
	
	//Name
	QLabel *label=new QLabel(tr("&Folder:"));
	folderLe_=new MvQLineEdit(this);
	label->setBuddy(folderLe_);
	gridLayout->addWidget(label,row,0);
	gridLayout->addWidget(folderLe_,row,1);
	row++;
	
	subFolderCheck_=new QCheckBox(tr("Include &subfolders"));
	gridLayout->addWidget(subFolderCheck_,row,1);
	row++;
	
	//Name
	label=new QLabel(tr("&Name:"));
	nameLe_=new MvQLineEdit(this);
	label->setBuddy(nameLe_);
	gridLayout->addWidget(label,row,0);
	gridLayout->addWidget(nameLe_,row,1);
	row++;
	
	//Type
	label=new QLabel(tr("&Type:"));
	typeLe_=new MvQLineEdit(this);
	label->setBuddy(typeLe_);
	gridLayout->addWidget(label,row,0);
	gridLayout->addWidget(typeLe_,row,1);
	row++;
	
	//Contains
	label=new QLabel(tr("&Containing text:"));
	contLe_=new MvQLineEdit(this);
	label->setBuddy(contLe_);
	gridLayout->addWidget(label,row,0);
	gridLayout->addWidget(contLe_,row,1);
	row++;
	
	//------------------
	// Properties tab 
	//------------------
	
	QGridLayout *propLayout=new QGridLayout;
	
	w=new QWidget;	
	w->setLayout(propLayout);	
	tab->addTab(w,tr("&Properties"));
		
	//Results view
	resTree_=new QTreeWidget(this);
	vb->addWidget(resTree_);
	
	//-------------------
	//Buttonbox
	//-------------------
	
	QDialogButtonBox *buttonBox= new QDialogButtonBox(this);
	vb->addWidget(buttonBox);
	
	buttonBox->addButton(QDialogButtonBox::Close);	
	connect(buttonBox,SIGNAL(rejected()),
		this,SLOT(reject()));
		
	
	//connect(filterList_,SIGNAL(itemActivated(QListWidgetItem*)),
	//	this,SLOT(slotIconSelected(QListWidgetItem*)));	
		
	/*connect(nameLe_,SIGNAL(textChanged(QString)),
		filterModel_,SLOT(slotFilterName(QString)));	
		
	connect(typeLe_,SIGNAL(textChanged(QString)),
		filterModel_,SLOT(slotFilterType(QString)));	
		
	connect(typeLe_,SIGNAL(textChanged(QString)),
		filterModel_,SLOT(slotFilterType(QString)));		
		
	connect(resView_,SIGNAL(clicked(const QModelIndex&)),
		this,SLOT(slotSelected(const QModelIndex&)));	*/
	
}

void MvQAdvancedSearchDialog::slotFind()
{
}
