/***************************** LICENSE START ***********************************

 Copyright 2012 ECMWF and INPE. This software is distributed under the terms
 of the Apache License version 2.0. In applying this license, ECMWF does not
 waive the privileges and immunities granted to it by virtue of its status as
 an Intergovernmental Organization or submit itself to any jurisdiction.

 ***************************** LICENSE END *************************************/

#ifndef MvQFolderWatcher_H
#define MvQFolderWatcher_H
 
#include <QList>
#include <QMap>
#include <QObject>

#include <time.h>

class Folder;
class FolderPresenter;
class QTimer;

class MvQFolderWatcher : public QObject
{
Q_OBJECT  
  
public:
	static void add(FolderPresenter*);
	static void remove(FolderPresenter*);
	static void print();
	static void reload(FolderPresenter*);
	
	FolderPresenter* folderPresenter() {return presenter_;}
	Folder* folder();
	int timeout() const {return timeout_;}
	
public slots:
	void slotTimeout();
	
protected: 
	MvQFolderWatcher(FolderPresenter*,int timeout=10000);
	void doTimeout(bool);
	void reload();
	
	bool isTimeoutDue(time_t);
	static void cleanLog();
	
	FolderPresenter* presenter_;
	QTimer* timer_;
	int timeout_;
	static QList<MvQFolderWatcher*> items_;	
	static QMap<Folder*,time_t> timeoutLog_;
};

#endif
