/***************************** LICENSE START ***********************************

 Copyright 2012 ECMWF and INPE. This software is distributed under the terms
 of the Apache License version 2.0. In applying this license, ECMWF does not
 waive the privileges and immunities granted to it by virtue of its status as
 an Intergovernmental Organization or submit itself to any jurisdiction.

 ***************************** LICENSE END *************************************/

#ifndef GRIBTHERMO_H
#define GRIBTHERMO_H

#include "Thermo.h"
#include "ParamsThermo.h"   //Maybe remove it later

class MvNetCDF;

class GribThermo : public Thermo {

public:

   // Constructors
   GribThermo();
   GribThermo(const char*);

   // Destructor
   ~GribThermo();

   // Get input parameters
   bool getInputParameters(MvRequest&);

   // Process data and build all data structures
   bool processData();

   // Generate output request
   bool createOutputRequest(MvRequest&);

   // Create a default title
   string title();

private:

   MvThermoParams pars_;   //Maybe remove it later

};

#endif
