/***************************** LICENSE START ***********************************

 Copyright 2012 ECMWF and INPE. This software is distributed under the terms
 of the Apache License version 2.0. In applying this license, ECMWF does not
 waive the privileges and immunities granted to it by virtue of its status as
 an Intergovernmental Organization or submit itself to any jurisdiction.

 ***************************** LICENSE END *************************************/

// MvThermoParams.h - Nov2003/vk  - original file
// ParamsThermo.h   - Jan2014/fii - updated to new Thermo application
//
//  Hide extracting and checking of input request
//  parameters - to make Tephigrams.cc more readable!
//
//  Q&D struct with all member data directly accessible!
//

#ifndef MVTHERMOPARAM_H
#define MVTHERMOPARAM_H

#include <string>

#include "MvRequest.h"

enum EPointType { eAreaAverage, eGridPoint, eInterpolated };

using namespace std;

class MvThermoParams
{
 public:

   MvThermoParams();
   ~MvThermoParams();

   bool init( const MvRequest& );
   string formulaPrintName();

   // Wind flag info
   bool windFlag() { return windFlag_; }
   void windFlag(bool flag) { windFlag_ = flag; }

   bool   windFlag_;  // T - there is wind data
   double T1;
   double T2;
   double P1;
   double P2;
   string dewPointFormulaType_;
   int    uFieldId_;
   int    vFieldId_;
   int    tempId_;
   int    dewId_;
   int    lnPressId_;
   double lat_;
   double lon_;
   double lat2_;
   double lon2_;
double Wf;
   EPointType  pointType_;
   MvRequest dataReq_;

   string errorMsg_;
};

#endif
