/***************************** LICENSE START ***********************************

 Copyright 2012 ECMWF and INPE. This software is distributed under the terms
 of the Apache License version 2.0. In applying this license, ECMWF does not
 waive the privileges and immunities granted to it by virtue of its status as
 an Intergovernmental Organization or submit itself to any jurisdiction.

 ***************************** LICENSE END *************************************/

//
// .NAME:
//  PlotModConst
//
// .AUTHOR:
//  Gilberto Camara and Fernando Ii
//
// .SUMMARY:
//  General Definitions, Enumerations,
//  Macros and Constants used in PlotMod 
//

#ifndef PlotModConst_H
#define PlotModConst_H

#if 0
#include <Cached.h>

// Path length for UNIX files
#ifndef MAXPATHLEN
const  int MAXPATHLEN = 256;
#endif

// Default file for printing Requests
#ifndef OUT_REQUEST_FILE_defined
#define OUT_REQUEST_FILE_defined
static Cached OUT_REQUEST_FILE =   "request.dmp";
#endif

// Text line
const short MAXNAMEICON = 50;

// Time Tolerance
const double TIME_TOLERANCE = 0.3333; 
// 3 hours expressed in fractions of a day 
#endif

// ImageParameter Number taken from WMO Code Table 2
const int GRIB_IMAGE_PARAM_NUMBER = 127;

// Maximum number of Legends package allowed in Magics
const short MAX_LEGENDS_PACKAGE = 5;

#if 0
const bool SHADED     = true;
const bool NOT_SHADED = false ; 

// Request Classes
static Cached DATAVISDEF	= "DATAVISDEF";
static Cached DATA		= "DATA";
static Cached BACKVISDEF	= "BACKVISDEF";
static Cached COMMAND		= "COMMAND";
static Cached TEXT		= "TEXT";
static Cached LEGEND		= "LEGEND";
static Cached LEGEND_ENTRY	= "LEGEND_ENTRY";
static Cached NOCLASS		= "NOCLASS";
static Cached NOTYPE		= "NOTYPE";
static Cached PLOTWINDOW        = "PLOTWINDOW";
static Cached RETRIEVE          = "RETRIEVE";
static Cached READ              = "READ";
#endif

// Data Requests
//static Cached LIST_OF_POINTS 	= "LIST_OF_POINTS";
static string GRIB           	= "GRIB";
//static Cached BUFR           	= "BUFR";
//static Cached IMAGE          	= "IMAGE";
static string NETCDF            = "NETCDF";
#if 0
static Cached MATRIX         	= "MATRIX";
static Cached MATRIX1D         	= "MATRIX1D";
static Cached MATRIX2D         	= "MATRIX2D";
static Cached MATRIX3D         	= "MATRIX3D";
static Cached DRAWING        	= "DRAWING";
static Cached CURVE          	= "CURVE";
static Cached BAR_GRAPH      	= "BAR_GRAPH";
static Cached DOUBLE_CURVE   	= "DOUBLE_CURVE";
static Cached VECTOR_FIELD   	= "VECTOR_FIELD";
static Cached POLAR_FIELD    	= "POLAR_FIELD";
static Cached GEOPOINTS      	= "GEOPOINTS";
static Cached STATION		= "STATION";
static Cached BACKGROUND        = "BACKGROUND";
#endif

// Page visualization Definitions
static Cached MCOAST    	= "MCOAST";
static Cached PCOAST    	= "PCOAST";
static Cached MTEXT		= "MTEXT";
static Cached PTEXT		= "PTEXT";
static Cached MLEGEND		= "MLEGEND";
static Cached MAXIS		= "MAXIS";
static Cached PAXIS		= "PAXIS";
//static Cached PTEPHI		= "PTEPHI";
//static Cached MAGICS_PARAMETERS = "MAGICS_PARAMETERS";
static Cached ANNOTATION	= "ANNOTATION";

#if 0
// Page organization
static Cached INDEPENDENT       = "INDEPENDENT";
static Cached ROW_CONNECTED     = "ROW_CONNECTED";
static Cached AUTOMATIC         = "AUTOMATIC";
static Cached POSITIONAL        = "POSITIONAL";
static Cached HORIZONTAL        = "HORIZONTAL";
static Cached VERTICAL          = "VERTICAL";
static Cached BOTTOM            = "BOTTOM";
static Cached TOP               = "TOP";
#endif

// Data Visualization Definitions
//static Cached PIMAGE    	= "PIMAGE";
static Cached MCONT     	= "MCONT";
static Cached PCONT     	= "PCONT";
static Cached MGRAPH    	= "MGRAPH";
static Cached PGRAPH    	= "PGRAPH";
static Cached MWIND     	= "MWIND";
static Cached PWIND     	= "PWIND";
//static Cached POBS      	= "POBS";
static Cached MSYMB     	= "MSYMB";
static Cached PSYMB     	= "PSYMB";
static Cached PTACH     	= "PTACH";
static Cached ISOTACHS     	= "ISOTACHS";

// Command Definitions
//static Cached DEVICE		= "DEVICE";
static Cached DEVICEDRIVER	= "DEVICE_DRIVER";
static string PLOTSUPERPAGE     = "PLOT_SUPERPAGE";
static Cached PLOTPAGE          = "PLOT_PAGE";
//static Cached PLOTSUBPAGE       = "PLOT_SUBPAGE";
//static Cached SUPERPAGE		= "SUPERPAGE";
//static Cached PAGE		= "PAGE";
static Cached PAGES             = "PAGES";
//static Cached SUBPAGES          = "SUBPAGES";
static string NEWPAGE		= "NEWPAGE";
//static Cached DROP		= "DROP";
//static Cached CLEAN		= "CLEAN";
//static Cached STATE		= "STATE";
//static Cached NEXT		= "NEXT";
//static Cached FLUSHSUPERPAGE    = "FLUSHSUPERPAGE";
//static Cached MATCHINGINFO      = "MATCHING_INFO";
//static Cached EDITMAPPAGE	= "EDIT_MAP_PAGE";
//static Cached EDITMAPWIDGET	= "EDIT_MAP_WIDGET";
//static Cached PAGEWIDGET       	= "PAGE_WIDGET";

// Request Parameters
//static Cached ICON              = "ICON";

// Others
//static Cached YES		= "YES";
//static Cached NO		= "NO";
static Cached ON		= "ON";
//static Cached OFF		= "OFF";

#if 0
// PlotMod modules definitions

static Cached DEFAULT           = "Default";
static Cached NONE              = "None";
static Cached POSTSCRIPT        = "POSTSCRIPT";
static Cached X_WINDOW          = "X_WINDOW";
static Cached OPENGL            = "OpenGL";
static Cached MAGICS            = "Magics";
#endif

// Views
static const string MAPVIEW       = "MAPVIEW";
static const string GEOVIEW       = "GEOVIEW";
static const string CARTESIANVIEW = "CARTESIANVIEW";
static const string DEFAULTVIEW   = "GEOVIEW";

// Output devices
static const char* const MVPRINTER       = "PRINTER";
static const char* const MVSCREEN        = "SCREEN";
static const char* const MVPREVIEW       = "PREVIEW";
static const char* const MVFILE          = "FILE";
static const char* const MVSCREEN_DRIVER = "QTOUTPUT";

#if 0
static Cached EMPTY             = "EMPTY";

// Widgets
const char* const SCROLLWIDGETNAME = "Scroll";
const char* const ZOOMWIDGETNAME = "Zoom";
#endif

#endif

